package org.wfc.omada.api.maintenance.model;

import com.fasterxml.jackson.annotation.JsonProperty;
import io.swagger.annotations.ApiModelProperty;

import javax.validation.Valid;
import javax.validation.constraints.NotNull;
import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

/**
 * FileServerSiteBackupVo
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.SpringCodegen", date = "2024-12-04T11:40:12.680+08:00[Asia/Shanghai]")

public class FileServerSiteBackupVo   {
  @JsonProperty("serverConfig")
  private FileServerOpenApiVo serverConfig;

  @JsonProperty("filePath")
  private String filePath;

  @JsonProperty("siteIds")
  @Valid
  private List<String> siteIds = new ArrayList<>();

  public FileServerSiteBackupVo serverConfig(FileServerOpenApiVo serverConfig) {
    this.serverConfig = serverConfig;
    return this;
  }

  /**
   * Get serverConfig
   * @return serverConfig
  */
  @ApiModelProperty(required = true, value = "")
  @NotNull

  @Valid

  public FileServerOpenApiVo getServerConfig() {
    return serverConfig;
  }

  public void setServerConfig(FileServerOpenApiVo serverConfig) {
    this.serverConfig = serverConfig;
  }

  public FileServerSiteBackupVo filePath(String filePath) {
    this.filePath = filePath;
    return this;
  }

  /**
   * Saving path of directory for all backup config files, example: /backup. Parameter [filePath] should be 1 - 128 ASCII characters.
   * @return filePath
  */
  @ApiModelProperty(required = true, value = "Saving path of directory for all backup config files, example: /backup. Parameter [filePath] should be 1 - 128 ASCII characters.")
  @NotNull


  public String getFilePath() {
    return filePath;
  }

  public void setFilePath(String filePath) {
    this.filePath = filePath;
  }

  public FileServerSiteBackupVo siteIds(List<String> siteIds) {
    this.siteIds = siteIds;
    return this;
  }

  public FileServerSiteBackupVo addSiteIdsItem(String siteIdsItem) {
    this.siteIds.add(siteIdsItem);
    return this;
  }

  /**
   * Site ID list to backup, up to 300 entries are allowed for the site ID list.
   * @return siteIds
  */
  @ApiModelProperty(required = true, value = "Site ID list to backup, up to 300 entries are allowed for the site ID list.")
  @NotNull


  public List<String> getSiteIds() {
    return siteIds;
  }

  public void setSiteIds(List<String> siteIds) {
    this.siteIds = siteIds;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    FileServerSiteBackupVo fileServerSiteBackupVo = (FileServerSiteBackupVo) o;
    return Objects.equals(this.serverConfig, fileServerSiteBackupVo.serverConfig) &&
        Objects.equals(this.filePath, fileServerSiteBackupVo.filePath) &&
        Objects.equals(this.siteIds, fileServerSiteBackupVo.siteIds);
  }

  @Override
  public int hashCode() {
    return Objects.hash(serverConfig, filePath, siteIds);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class FileServerSiteBackupVo {\n");
    
    sb.append("    serverConfig: ").append(toIndentedString(serverConfig)).append("\n");
    sb.append("    filePath: ").append(toIndentedString(filePath)).append("\n");
    sb.append("    siteIds: ").append(toIndentedString(siteIds)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

